<template>
  <div
    class="p-10 grid grid-cols-2 sm:grid-cols-3 md:grid-cols-4 lg:grid-cols-6 xl:grid-cols-7 gap-4 content-center"
  >
    <div
      class="max-w-xs rounded overflow-hidden shadow-lg"
      v-for="book in books"
      v-bind:key="book.id"
      @click="openDetailsBook(book)"
    >
      <img
        v-if="book.volumeInfo.imageLinks?.thumbnail"
        class="w-full"
        :src="book.volumeInfo.imageLinks?.thumbnail"
        :alt="book.volumeInfo.title"
      />

      <img
        v-else
        class="w-full"
        src="../assets/no-cover.png"
        :alt="book.volumeInfo.title"
      />
      <div class="px-6 py-4">
        <div class="font-bold text-sm title">
          {{ book.volumeInfo.title }}
        </div>
        <div
          v-for="author in book.volumeInfo.authors"
          v-bind:key="author.id"
          class="text-xs mb-2"
        >
          {{ author }}
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import {
  searchABookByTitle,
} from "./../services/bookService";
export default {
  name: "Book",

  data() {
    return {
      books: [],
    };
  },

  props: {
    booksToSearch: {},
  },
  watch: {
    booksToSearch: async function displayBooks() {
      this.books = [];
      const result = await searchABookByTitle(this.booksToSearch, 0);
      // Evite d'afficher des doublons, ou des livres pas sortis
      result.items.forEach((book) => {
        if (book.volumeInfo.readingModes.text) {
          this.books.push(book);
        }
      });
      //this.books = result.items;
    },
  },

  methods: {
    openDetailsBook(book) {
      this.$router.push({
        name: "BookDetails",
        params: { isbnBook: this.getIsbn(book) },
      });
    },

    getIsbn(book) {
      let isbn = book.volumeInfo.industryIdentifiers.find(
        (type) => type.type === "ISBN_13"
      );
      return isbn.identifier;
    },
  },
};
</script>

<style scoped>
.description {
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  -webkit-line-clamp: 5; /* number of lines to show */
  -webkit-box-orient: vertical;
}

.title {
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  -webkit-line-clamp: 2; /* number of lines to show */
  -webkit-box-orient: vertical;
}

img {
  object-fit: fill;
}
</style>
